{% extends "layouts/presentations/lang_fast_track.njk" %}

{% set title = "Programming in C++" %}
{% set subtitle = "Fast Track to C++ Syntax for (C) Programmers" %}

{% set language = "C++" %}
{% set language_ = "cpp" %}
{% set clang = "clang++" %}
{% set gcc = "g++" %}


{% block cpp_io_streams %}
<p>While <code>&lt;stdio.h&gt;</code> (printf, scanf etc.) is available,
  {{ language }} allows using I/O streams</p>
{% endblock %}

{% block cpp_initialization %}
    <p>C++ has a native <code>bool</code> data type</p>
    <p>C++ also offers <strong>constructor initialization</strong>
      <code>()</code> and
      <strong>uniform initialization</strong> <code>{}</code></p>
{% endblock %}

{% block cpp_types %}
  <section>
    <p>C++ offers type deduction: <code>auto</code> and
      <code>decltype</code></p>
    <p>Both should only be used to increase readability</p>
{% highlight "cpp" %}
{% include "source/cpp/fast_track/type_deduction.cpp" %}
{% endhighlight %}
{% include_code "source/cpp/fast_track/type_deduction.cpp" %}
  </section>

  <section>
    <h3>References</h3>
    <p>{{ language }} supports references which are more programmer friendly
      than pointers
    </p>
{% highlight "cpp" %}
{% include "source/cpp/fast_track/reference.cpp" %}
{% endhighlight %}
{% include_code "source/cpp/fast_track/reference.cpp" %}
  </section>

  <section>
    <p>The C++ STL offers container data types</p>
{% highlight language_ %}
{% include "source/cpp/fast_track/container_types.cpp" %}
{% endhighlight %}
{% include_code "source/cpp/fast_track/container_types.cpp" %}
  </section>
{% endblock %}

{% block cpp_for %}
  <section>
    <h3>Iterators</h3>
    <p>{{ language }} provides iterators (incl. reverse and const iterators)</p>
{% highlight language_ %}
for (auto it = container.begin(); it != container.end(); ++it) {
  // block using `*it`
}
{% endhighlight %}
  </section>

  <section>
    <h3>Example: Iterators</h3>
{% highlight language_ %}
{% include "source/cpp/iterator_for.cpp" %}
{% endhighlight %}
{% include_code "source/cpp/iterator_for.cpp" %}
  </section>

  <section>
    <h3>Range-Based For Loops</h3>
    <p>{{ language }} provides easy access each element in a container</p>
{% highlight language_ %}
for (const auto& element : container) {
   // block
}
{% endhighlight %}
  </section>

  <section>
    <h3>Example: Perform Action on Each Element</h3>
{% highlight language_ %}
{% include "source/cpp/range_based_for.cpp" %}
{% endhighlight %}
{% include_code "source/cpp/range_based_for.cpp" %}
  </section>
{% endblock %}

{% block cpp_functions %}
  <section>
    <h2>Pass by Reference</h2>
    <p>{{ language }} allows passing references to arguments</p>
{% highlight language_ + " 2,10" %}
{% include "source/cpp/by_reference.cpp" %}
{% endhighlight %}
{% include_code "source/cpp/by_reference.cpp" %}
  </section>

  <section>
    <h2>Function Overloading</h2>
    <p>{{ language }} allows function names to be used in multiple
      signatures</p>
{% highlight language_ + " 1,2,11,16" %}
{% include "source/cpp/fast_track/overloading.cpp" %}
{% endhighlight %}
{% include_code "source/cpp/fast_track/overloading.cpp" %}
  </section>

  <section>
    <h2>Function Templates</h2>
    <p>{{ language }} functions can operate with generic
      types to avoid code duplication</p>
{% highlight language_ + " 1,2,10,11" %}
{% include "source/cpp/fast_track/function_template.cpp" %}
{% endhighlight %}
{% include_code "source/cpp/fast_track/function_template.cpp" %}
  </section>

{% endblock %}

{% block cpp_content %}

<section>
<h2>Namespaces</h2>
  <p>{{ language }} handles namespaces explicitly.</p>
  <p>It is possible to avoid constantly prepending a namespace with the
    <code>using</code> keyword.
  </p>
  {% highlight language_ + " 2,3,6" %}
  {% include "source/cpp/fast_track/using.cpp" %}
  {% endhighlight %}
  {% include_code "source/cpp/fast_track/using.cpp" %}
</section>

<section>
  <h2>Resources</h2>

  <p>{{ language }} has too much more to offer to stuff into a single
    presentation. Good places to start looking for more are
  </p>
  <ul>
    <li><a href="https://en.cppreference.com/">C++ reference</a></li>
    <li><a href="https://www.cplusplus.com/">cplusplus.com</a></li>
  </ul>
</section>

{% endblock %}

